#include <iostream>
#include <cctype>
#include <EasyAssert.h>
#include <cassert>

using namespace std;
bool carDeMot (const char & car) {
    return (islower (car) || isupper(car) ||
            isdigit (car) || car == '_');
}

//approche mot/mot
size_t compterNbMotsDef0MotMot (const string & chaine) {
    size_t cpt (0), i (0);

    while (true){
        //on se positionne sur le début du prochain mot
        while ((i < chaine.size()) &&  (! carDeMot (chaine [i]))){
            i = i + 1;
        }
        if (i == chaine.size()) break;

        //si on ne sort pas, c'est qu'on est sur le debut d'un mot
        cpt = cpt + 1;

        //on passe le mot courant
        while (i < chaine.size() && carDeMot (chaine [i])){
            i = i + 1;
        }
    }
    return cpt;
}

//approche caractere/caractere
size_t compterNbMotsDef0CarCar (const string & chaine) {
    size_t cpt (0);
    bool estDansMot (false);

    for (size_t i (0); i  < chaine.size() ; ++i){
        //on identifie le debut d'un nouveau mot
        if (!estDansMot && carDeMot (chaine [i])) {
            cpt = cpt + 1;
            estDansMot = true;
        }
        //on identifie la fin du mot courant
        else if (estDansMot && !carDeMot (chaine [i])){
            estDansMot = false;
        }
    }
    return cpt;
}

void test_compterNbMotsDef0MotMotAvecLectureClavier () {
    //attiention, pour lire une ligne, qui contient des espaces,
    //il faut remplcer le code :
    //string ligne;
    //cin >> ligne
    //string ligne;
    //getline (cin, ligne);
}

void test_compterNbMotsDef0MotMotAvecEasyAssert () {

}

void test_compterNbMotsDef0MotMotAvecAssert () {

}

void test_compterNbMotsDef0MotMotAvecFichierOracle () {

}

void test_NonRegressionCompterNbMotsDef0CarCarAvecAssertion() {

}

void test_NonRegressionCompterNbMotsDef0CarCarAvecFichierOracle() {

}

void lectureDUneLigneAuClavier (){
    string ligne;
    cout << "entrer une ligne : " << endl;
    cin >> ligne;
//    getline (cin, ligne);
    cout << ligne;
}

void testCoppieFichier (){
    for (string ligne; getline(cin, ligne); ){
        cout << ligne << endl;;
    }
}

int main()
{
    lectureDUneLigneAuClavier();
    //testCoppieFichier();
    //test_compterNbMotsDef0MotMotAvecLectureClavier ();
    //test_compterNbMotsDef0MotMotAvecEasyAssert ();
    //test_compterNbMotsDef0MotMotAvecFichierOracle ();
    //test_NonRegressionCompterNbMotsDef0CarCarAvecAssertion ();
    //test_NonRegressionCompterNbMotsDef0CarCarAvecFichierOracle ();

    return 0;
}
